/*
    Aufgabe 3, 4, 5,) Zweidimensionale Arrays -- Vier Gewinnt

    Beim Spiel "Vier gewinnt" gewinnt der Spieler, der als erstes vier Steine
    in eine Reihe bringt (horizontal, vertikal, oder diagonal). Das Spielfeld
    steht senkrecht und ist 7 Spalten breit und 6 Reihen hoch. Steine können nur
    im untersten Feld einer Spalte platziert werden, das noch nicht von einem
    anderen Stein besetzt ist.

    "Vier gewinnt" wird in mehreren, aufeinander aufbauenden Aufgaben in
    mehreren Aufgabenblättern verwendet, Sie sollten daher diese Aufgaben
    unbedingt lösen. In diesem Aufgabenblatt deckt das Spiel "Vier gewinnt"
    3 Aufgaben ab. Bitte kreuzen Sie diese separat in TUWEL an.
    
    Hinweis: Sie können Hilfsmethoden implementieren, dürfen aber vorgegebene
             Methoden und deren Signaturen nicht verändern.
    
    *****************************  Aufgabe 3  **********************************
    Für Aufgabe 3 schreiben Sie folgende statische Methoden:

    1) public static int[][] spielfeld()
    
    Diese Methode erzeugt ein leeres Vier-Gewinnt-Spielfeld. Das Spielfeld soll
    als zweidimensionales Array von int-Werten dargestellt werden, wobei auf
    ein Feld in Reihe r und Spalte s im Feld f mit f[r][s] zugegriffen werden
    soll. Ein leeres Feld wird mit 0 repraesentiert, ein Stein auf einem Feld
    durch 1 für einen Stein des Spielers 1 bzw. 2 für einen Stein des
    Spielers 2.

    2) public static void spielstand(int[][] f)
    
    Diese Methode gibt den Spielstand f in folgender Form aus:
    
    |       |
    |       |
    |       |   Definition: Die linke unterste Ecke ist als Koordinate [0][0]
    |       |               definiert und stellt den Ausgangspunkt des
    |  xo   |               Spielbrettes dar.
    |  ox   |
    +-------+
    
    wobei für ein leeres Feld ein Leerzeichen ausgegeben wird, für einen Stein
    von Spieler 1 ein x, und für einen Stein von Spieler 2 ein o.
    
    Zusatzfragen:
    1. Welche anderen Möglichkeiten neben der von Ihnen gewählten gibt es, um
    von der Spielernummer auf x bzw. o zu kommen?
    ****************************************************************************
    
    *****************************  Aufgabe 4  **********************************
    Für Aufgabe 4 schreiben Sie folgende statische Methoden:

    1) public static int[][] zug(int[][] f, int spieler, int spalte)

    Diese Methode führt einen Zug des Spielers "spieler" in Spalte
    "spalte" (0-6 für legale Züge) durch und gibt die neue Stellung
    (das Spielfeld nach dem Zug) zurück.  Wenn in Spalte "spalte" kein
    Zug möglich ist (weil die Spalte voll ist oder nicht im erlaubten
    Bereich), soll zug() null zurückgeben.  Das vom Parameter f
    referenzierte Feld darf verändert werden oder unverändert bleiben.

    2) public static boolean sieg(int[][] f, int spieler)

    Diese Methode liefert true, wenn "spieler" vier Steine in einer Reihe hat,
    sonst false.

    Zusatzfragen:
    1. Welche Vor- und Nachteile hat es für dieses Beispiel und in
    Hinblick auf Aufgabe 5, den Parameter f von zug() zu verändern.
    ****************************************************************************

    *****************************  Aufgabe 5  **********************************
    Für Aufgabe 5 schreiben Sie folgende statische Methode:

    1) public static void spiel()

    Diese Methode führt ein Vier-Gewinnt-Spiel zwischen zwei Spielern durch:
    Beginnend mit einem leeren Spielfeld werden abwechselnd Spieler 1 und
    Spieler 2 zur Eingabe eines Spielzuges aufgefordert, der Spielzug
    durchgeführt, und der aktuelle Spielstand ausgegeben, solange bis ein
    Spieler gewonnen hat oder das Spielfeld voll ist. Überlegen Sie sich
    eine sinnvolle Behandlung von ungültigen Eingaben. In "main" wird am Ende
    nur noch die Methode spiel() aufgerufen. Testen Sie spiel() selbst, auch
    den Fall, dass das Spielfeld voll wird, ohne dass ein Spieler gewonnen hat.

    Zusatzfragen:
    1. Was machen Sie bei ungültigen Eingaben?
    ****************************************************************************
*/
import java.util.Scanner;

public class Aufgabe3 {

    //***************************  Aufgabe 3  **********************************
    public static int[][] spielfeld(){
        // TODO: Implementieren Sie hier die Angabe
        return new int[6][7]; //diese Anweisung ändern oder löschen.
    }
    
    public static void spielstand(int[][] f){
        char[] chars = {' ', 'x', 'o'};
        for (int i = f.length - 1; i >= 0; i--) {
            System.out.print("|");
            for (int j = 0; j < f[i].length; j++) {
                System.out.print(chars[f[i][j]]);
            }
            System.out.println("|");
        }
        System.out.println("+-------+");
    }
    //**************************************************************************
    
    
    //***************************  Aufgabe 4  **********************************
    public static int[][] zug(int[][] f, int spieler, int spalte){
        parentLoop: for (int i = 0; i < f.length; i++) {
            if (spalte > f.length || spalte < 0) { return null; }

            for (int j = 0; j < f[i].length; j++) {
                if (j == spalte && f[i][j] == 0) {
                    f[i][j] = spieler;
                    break parentLoop;
                }
                if (i == f.length - 1 && f[i][j] != 0 && j == spalte) {
                    return null;
                }
            }
        }

        return f;
    }
    
    public static boolean sieg(int[][] f, int spieler) {
        for (int i = 0; i < f.length - 1; i++) {
            for (int j = 0; j <= f[i].length - 1; j++) {
                // horizontal => only allowed for the first f[i].length - 4 columns
                if (j <= f[i].length - 4 && spieler == f[i][j] && spieler == f[i][j+1] && spieler == f[i][j+2] && spieler == f[i][j+3]) {
                    return true;
                }
                // vertical => only allowed for the first f.length - 4 rows
                if (i <= f.length - 4 && spieler == f[i][j] && spieler == f[i+1][j] && spieler == f[i+2][j] && spieler == f[i+3][j]) {
                    return true;
                }
                // diagonal \ => only allowed for the first f.length - 4 rows and for the first f[i].length - 4 colums
                if (i <= f.length - 4 && j <= f[i].length - 4 && spieler == f[i][j] && spieler == f[i+1][j+1] && spieler == f[i+2][j+2] && spieler == f[i+3][j+3]) {
                    return true;
                }
                // diagonal / => only allowed for the first f.length - 4 rows and for the last f[i].length - 4 colums
                if (i <= f.length - 4 && j >= f[i].length - 4 && spieler == f[i][j] && spieler == f[i+1][j-1] && spieler == f[i+2][j-2] && spieler == f[i+3][j-3]) {
                    return true;
                }
            }
        }

        return false;
    }
    //**************************************************************************
    
    public static boolean spielfeldVoll(int[][] f) {
        for (int i = 0; i<f.length; i++) {
            for (int j = 0; j<f[i].length; j++) {
                if (f[i][j] == 0) {
                    return false;
                }
            }
        }
        return true;
    }
    //***************************  Aufgabe 5  **********************************
    public static void spiel(){
        Scanner scanner = new Scanner(System.in);
        int[][] f = spielfeld();
        int runde = 1;

        while (true) {
            int spieler = runde % 2 == 0 ? 2 : 1;
            System.out.println("Spieler " + spieler + " ist dran, tippe die Spalte ein!");
            spielstand(f);
            
            if (sieg(f, 1) || sieg(f, 2)) {
                System.out.println(sieg(f, 1) ? "SIEG: Spieler 1" : "SIEG: Spieler 2");
                return;
            }

            if (spielfeldVoll(f)) {
                System.out.println("ENDE: Spielfeld voll, unentschieden!");
                return;
            }

            if (scanner.hasNextInt()) {
                int spalte = scanner.nextInt() - 1;
                int[][] temp = zug(f, spieler, spalte);
                if (temp != null) {
                    f = temp;
                    runde++;
                } else {
                    System.out.println("Ungültige oder volle Spalte!");
                }
            } else {
                System.out.println("Ungültige Eingabe, bitte geben Sie eine Zahl von 1-7");
            }
        }
    }
    //**************************************************************************

    public static void main(String[] args) {
        spiel();
    }
}

