import java.util.*;

class Person {
    private String vorname;
    private String nachname;
    private String geschlecht;
    private int alter;
    private int SVNr;
    private List kinder;
    private static int count = 0;

    public Person(String vorname, String nachname, String geschlecht, int alter, int SVNr) {
        this.vorname = vorname;
        this.nachname = nachname;
        this.geschlecht = geschlecht;
        this.alter = alter;
        this.SVNr = SVNr;
        this.kinder= new ArrayList<Person>();
    }

    public void neuesKind(Person p) {
        if(p == null || p.equals(this)){
            return;
        }

        for (Object k: this.kinder){
            if(k.equals(p)){
                return;
            }
        }

        kinder.add(p);
    }

    public int hashCode() {
        int result = this.kinder != null ? kinder.hashCode() : 0;
        result = 2222 * result + (this.vorname != null ? this.vorname.hashCode() : 0);
        result = 2222 * result + (this.nachname != null ? this.nachname.hashCode() : 0);
        result = 2222 * result + (this.geschlecht != null ? this.geschlecht.hashCode() : 0);
        result = 2222 * result + this.alter;
        result = 2222 * result + this.SVNr;
        return result;
    }

    public boolean equals(Object o) {
        if (o == null || ! (o instanceof Person)) {
            return false;
        }
        Person p = (Person) o;

        return this.SVNr == p.SVNr && p.vorname.equals(this.vorname) && p.nachname.equals(this.nachname);
    }

    public String toString() {
        String result = "";

        result += repeat(" ", Person.count);

        result += "# " + this.vorname + " " + this.nachname + ", " + this.geschlecht
                + ", " + this.alter + " Jahre, Svnr: " + this.SVNr;
        
        for (Object p: this.kinder){
            Person.count++;
            result += "\n"+p.toString();
        }

        if (Person.count > 0) {
            Person.count--;
        }

        return result;
    }

    private String repeat(String s, int times) {
        return times > 0 ? s + repeat(s, times - 1) : "";
    }

    public static void main(String[] args) {}
}
