/*
    Aufgabe 2) Eingabe und Ausgabe mit Dateien

    Es soll ein Textfile "Geschichte.txt" geöffnet und eingelesen werden.
    Durchsuchen Sie das File nach sogenannten Palindromen (z.b. Hannah, Otto,
    etc.), also Wörtern die von vorn und von hinten gelesen dasselbe ergeben.
    Implementieren Sie dazu eine statische Methode "searchPalindrome(...)", die
    als Argumente die Filenamen für die Ein- und Ausgabe übergeben bekommt.
    Schreiben Sie alle gefundenen Palindrome in die Datei "Palindrome.txt".
    Zusätzlich geben Sie alle Palindrome mit System.out.println(...) aus (in der
    Reihenfolge in der diese im File auftreten).

    Erstellen Sie zusätzlich (unabhängig von Palindromen) eine Statistik über
    alle vorkommenden Buchstaben (auch Umlaute bzw. ein scharfes ß sollen, falls
    vorhanden, aufgelistet werden).
    Groß- und Kleinbuchstaben werden nicht unterschieden. Implementieren Sie
    dazu eine statische Methode "generateStatistic(...)" und geben Sie die
    Ergebnisse in folgender Form aus:
    Buchstabe - Gesamt (Wie oft kommt Buchstabe vor)
    z.B.:   a - 17
            b - 3
            c - 2
            ...

    Zusatzfragen:
    1. Was ist der Unterschied zwischen ungepufferten und gepufferten
       Datenströmen?
    2. Was ist der Unterschied zwischen FileInputStream und FileReader?
*/

import java.io.*;

public class Aufgabe2 {

    public static void searchPalindrome(String inFileName, String outFileName) throws IOException {
        String content = fileContent(inFileName);
        FileWriter fw = new FileWriter("Aufgabe2/tasks/" + outFileName);

        // split at any of the following: " " "." "," "?" "!"
        // \\W does not work because it splits at the ß
        String[] words = content.split("[\\s\\.,\\?\\!]+");

        for (String w: words) {
            if (isPalindrom(w)) {
                System.out.println(w);
                fw.append(w + "\n");
            }
        }
        fw.close();
    }

    public static boolean isPalindrom(String s) {
        return s.toLowerCase().equals(new StringBuilder(s).reverse().toString().toLowerCase());
    }
    
    public static void generateStatistic(String inFileName) throws IOException {
        String input = fileContent(inFileName).toLowerCase();
        int[] alphabet = new int[30];
        char[] special = new char[]{'ä', 'ö', 'ü', 'ß'};

        for (int i = 0; i < input.length(); i++ ) {
            int letter = (int) input.charAt(i);
            if (letter >= 97 && letter <= 122) alphabet[letter-'a']++;
            // äöüß
            if (letter == 228) { alphabet[26]++; }
            if (letter == 246) { alphabet[27]++; }
            if (letter == 252) {  alphabet[28]++; }
            if (letter == 223) { alphabet[29]++; }
        }
        for (int i = 0; i < alphabet.length; i++) {
            if (alphabet[i] > 0) {
                System.out.println((i < 26 ? (char) ('a' + i) : special[i-26]) + " - " + alphabet[i]);
            }
        }
    }

    public static String fileContent(String filename) throws IOException {
        StringBuffer content = new StringBuffer();
        Reader in = new BufferedReader(new InputStreamReader(new FileInputStream("Aufgabe2/tasks/" + filename), "UTF8"));

        for (int text = in.read(); text >= 0; text = in.read()) {
            content.append((char) text);
        }

        in.close();

        return content.toString();
    }
    
    public static void main(String[] args) throws IOException {
        searchPalindrome("Geschichte.txt", "");
    }
}

